QGIS Application - Bug report #16172
DB-Manager: new GeoPackage tables display wrong values
2017-02-10 01:36 AM - Jéréme Guélat

Status: Closed

Priority: Normal

Assignee: Even Rouault

Category: DB Manager

Affected QGIS version:master Regression?: No
Operating System: GNU/Linux Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 24082
Description

Here's how to reproduce the problem:

1. Open DB-Manager, create a connection with a GeoPackage

2. Create a new table with the SQL command CREATE TABLE foo AS SELECT * FROM bar
3. Re-connect the GeoPackage to see the new table (using refresh doesn't work)

4. Select the new table in DB-Manager and click on the "Table" tab

Wrong values are displayed... However if you add the table to the canvas and open the attribute table, then the correct values will be
shown.

History

#1 - 2017-05-01 01:01 AM - Giovanni Manghi
- Easy fix? set to No
- Regression? set to No

#2 - 2017-09-05 09:14 PM - gcarrillo -
- File ogrinfo.png added
- Description updated

- File qgis_2_99.png added
- File qgis_2_14_12.png added

| can confirm this issue running on QGIS 2.99 (68909a1).

Showing a table from GeoPackage database works fine in QGIS 2.14.12 (DB Manager) and from ogrinfo. DB Manager in QGIS v2.99 (68909a1) cannot
show values properly, and shifts them one column to the left, apparently to make space for an auto-increment field.

QGIS 2.14.12:
QGIS 2.99 (68909a1):
2 | chinterlis.ili2c.ilidirs %ILI_FROM_DB;%XTF_DIR;http://models.interlis.ch/;%AR_DIR
3 | ch.ehi.ilizdb.numericCheckConstraints create
4 | ch.ehi.ilizdb.sender ili2gpkg-3.10.5-20170818
5 |ch.ehiili2db.createForeignkey yes
6 | ch.ehi.sglgen.createGeomIndex True
7 | ch.ehiilidb.defaultSrsAuthority EPSG
8 |ch.ehi.ilizdb.defaultSrsCode 3116
9 | ch.ehi.ilizdb.createEnumDefs multiTable
10 | ch.ehi.ilizdb.maxSqlNameLength 60
11 | ch.ehiili2db.inheritanceTrafo smart2
12 | ch.ehi.ilizdb.catalogueRefTrafo coalesce
13 | ch.ehi.ilizdb.geomAttrPerTable oneGeomAtirPerTable
14 | ch.ehi.ilizdb.multiLineTrafo coalesce
15 | ch.ehi.ilizdb.multiSurfaceTrafo coalesce
16 | ch.ehiilizdb.multilingualTrafo expand
Output of ogrinfo:
ogrinfo /docs/borrar/gpkg/a.gpkg -sql "SELECT * FROM T_ILI2DB_SETTINGS"
INFO: Open of ' /docs/borrar/gpkg/a.gpkg’
using driver "GPKG' successful.

Layer name: SELECT

Geometry: None

Feature Count: 16

Layer SRS WKT:

(unknown)

tag: String (608.08)

setting: String (255.0)

0GRFeature(SELECT): 0@
tag (String) = ch.ehi.ili2db.createMetaInfo
setting (5tring) = True

OGRFeature(SELECT):1
tag (String) = ch.interlis.ili2c.ilidirs
setting (5tring) = %ILI_FROM DB;%XTF_DIR;http://models.interlis.ch/;%JAR_DIR

OGRFeature(SELECT):2
tag (String) = ch.ehi.ili2db.numericCheckConstraints
setting (String) = create

OGRFeature(SELECT):3
tag (String) = ch.ehi.ili2db.sender
setting (S5tring) = ili2gpkg-3.10.5-201760818

OGRFeature(SELECT) :4
tag (String) = ch.ehi.ili2db.createForeignKey
setting (String) = yes

0GRFeature(SELECT):5
tag (String) = ch.ehi.sqglgen.createGeomIndex
setting (S5tring) = True

OGRFeature(SELECT) :6
tag (String) = ch.ehi.ili2db.defaultSrsAuthority
setting (S5tring) = EPSG

OGRFeature(SELECT) :7
tag (String) = ch.ehi.ili2db.defaultSrsCode
setting (5tring) = 3116

#3 - 2017-09-05 09:15 PM - gcatrrillo -
- Operating System set to GNU/Linux
- Affected QGIS version changed from 2.18.3 to master

#4 - 2017-11-09 04:31 PM - Even Rouault
- Status changed from Open to Closed
- Resolution set to invalid

| cannot reproduce with master. And actualy this way of creating tables is not supported in GeoPackage with recent GDAL version since non-spatial tables
("attributes” in geopackage parlance) must also be registered in the gpkg_contents system table, otherwise they will be invisible as soon as a properly
registered "attributes" table is created
